package au.com.explodingsheep.diskDOM;


import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.identifier.*;


/**
 * My version of a Comment.
 */

public class DefaultMyComment extends DefaultMyCharacterData implements MyComment, HasValueIdentifier
{
  /**
   * Constructor.
   */
  
  public DefaultMyComment( Identifier instanceID,
                     Identifier identifier, 
                     IdentifierIdentifier parent, 
                     String prefix,
                     String namespaceURI,
                     String nodeName,
                     int nodeType,
                     Identifier value,
                     Identifier document )
  {
    super( instanceID,
            identifier, 
            parent, 
            null,
            prefix,
            namespaceURI,
            nodeName,
            nodeType,
            value,
            document,
            false );
  }

  
  /*------------------------- Overridden Node methods -----------------------*/

  
  /**
   * Return "#comment".
   */
  
  public String getNodeName()
  {
    return "#comment";
  }
  

  /**
   * Clones this element node.
   */
  
  public Node cloneNode(boolean deep)
  {
    Node result = null;
    
    if ( deep == true )
    {
      super.cloneNode( true );
    }
    else
    {
      Document document = super.getOwnerDocument();
      String value = this.getNodeValue();
      result = document.createComment( value );
    }
    
    return result;
  }
  
  
  /**
   * A processing instruction instruction has no child nodes so
   * return an empty nodelist.
   */
  
  public NodeList getChildNodes()
  {
    NodeList result = new au.com.explodingsheep.diskDOM.helpers.EmptyNodeList();
    return result;
  }


  /*----------------------- HasValueIdentifier methods -----------------------*/
  
  
  /**
   * Returns the Identifier to the value of the node.
   */

  public au.com.explodingsheep.diskDOM.identifier.Identifier getValueIdentifier()
  {
    return this.value;
  }
}
