package au.com.explodingsheep.diskDOM;


import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.identifier.*;


/**
 * Implementation of the MyEntity interface.
 */

public class DefaultMyEntity extends DefaultMyNode implements MyEntity
{
  protected String publicID = null;
  protected String systemID = null;
  protected String notationName = null;
  
  
  /**
   * Constructor.
   */
  
  public DefaultMyEntity( Identifier instanceID,
                    Identifier identifier, 
                    IdentifierList children, 
                    String prefix,
                    String namespaceURI,
                    String nodeName,
                    Identifier document,
                    String publicID,
                    String systemID,
                    String notationName )
  {
    super( instanceID,
            identifier, 
            null, 
            children, 
            prefix,
            namespaceURI,
            nodeName,
            Node.ENTITY_NODE,
            document,
            false );
    this.publicID = publicID;
    this.systemID = systemID;
    this.notationName = notationName;
  }

  
  /*------------------------- Entity methods --------------------------------*/
  
  
  /**
   * For unparsed entities, the name of the notation for the entity. 
   */
  
  public String getNotationName() 
  {
    return this.notationName;
  }
          
          
  /**
   * The public identifier associated with the entity, if specified. 
   */
  
  public String getPublicId() 
  {
    return this.publicID;
  }
          
  
  /**
   * The system identifier associated with the entity, if specified. 
   */
  
  public String getSystemId() 
  {
    return this.systemID;
  }
}
