package au.com.explodingsheep.diskDOM;


import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.identifier.*;


/**
 * Implementation of the MyEntityReference interface.
 */

public class DefaultMyEntityReference extends DefaultMyNode implements MyEntityReference
{
  /**
   * Constructor.
   */
  
  public DefaultMyEntityReference( Identifier instanceID,
                             Identifier identifier, 
                             IdentifierIdentifier parent, 
                             IdentifierList children, 
                             String prefix,
                             String namespaceURI,
                             String nodeName,
                             int nodeType,
                             Identifier document,
                             boolean readOnly )
  {
    super( instanceID,
            identifier, 
            parent, 
            children, 
//            attributes,
            prefix,
            namespaceURI,
            nodeName,
            nodeType,
//            value,
            document,
            readOnly );
  }


  /*------------------------- Overridden Node methods -----------------------*/

  
  /**
   * Clones this element node.
   */
  
  public Node cloneNode(boolean deep)
  {
    Node result = null;
    
    if ( deep == true )
    {
      result = super.cloneNode( true );
    }
    else
    {
      Document document = super.getOwnerDocument();
      String name = this.getNodeName();
      result = document.createEntityReference( name );
    }
        
    return result;
  }
}
