package au.com.explodingsheep.diskDOM;


import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.identifier.*;


/**
 * My version of an Element.
 */

public class DefaultMyNotation extends DefaultMyNode implements MyNotation
{
  protected String publicID = null;
  protected String systemID = null;
  
  
  /**
   * Constructor.
   */
  
  public DefaultMyNotation( Identifier instanceID,
                      Identifier identifier, 
                      IdentifierIdentifier parent,
                      String prefix,
                      String namespaceURI,
                      String nodeName,
                      String publicID,
                      String systemID,
                      Identifier document )
  {
    super( instanceID,
            identifier, 
            parent, 
            null,
            prefix,
            namespaceURI,
            nodeName,
            Node.NOTATION_NODE,
            document,
            true );
    this.publicID = publicID;
    this.systemID = systemID;
  }

  
  /*-------------------- Overridden Node methods ------------------------*/
  
  
  /**
   * Returns the parent node of this node.
   * Because this is an Attribute it should return null here.
   */
  
  public Node getParentNode()
  {  
    return null;
  }


  /**
   * A processing instruction instruction has no child nodes so
   * return an empty nodelist.
   */
  
  public NodeList getChildNodes()
  {
    NodeList result = new au.com.explodingsheep.diskDOM.helpers.EmptyNodeList();
    return result;
  }
  
  
  /*------------------------ Notation methods ---------------------------*/
  
  
  /**
   * The public identifier of this notation. 
   * If the public identifier was not specified, this is null. 
   */
  
  public String getPublicId()
  {
    return this.publicID;
  }
  

  /**
   * The system identifier of this notation. 
   * If the system identifier was not specified, this is null. 
   */
  
  public String getSystemId()
  {
    return this.systemID;
  }
}
