package au.com.explodingsheep.diskDOM;


import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.identifier.*;
import au.com.explodingsheep.diskDOM.nodeStore.*;


/**
 * My version of the Document interface.
 */

public interface MyDocument extends Document, MyNode
{
  /**
   * Returns an identifier to the DocumentType associated
   * with this document.
   */
  
  public Identifier getDocumentTypeIdentifier();
  
  
  /**
   * Associates a DocumentType with this Document.
   */
  
  public void setDocumentType( MyDocumentType documentType );


  /**
   * Creates an Entity object. This method is not part of the
   * Document interface, it is part of MyDocument.
   */

  public Entity createEntity(String entityName, String publicID, String systemID, String notationName ) throws DOMException;


  /**
   * Creates an Entity object. This method is not part of the
   * Document interface, it is part of MyDocument.
   */

  public Notation createNotation( String notationName, String publicID, String systemID ) throws DOMException;


  /**
   * When a MyDocumentBuilder is closed, all the MyDocuments in it
   * are also closed. 
   * When a MyDocumentBuilder is re-opened, and its parsed node file
   * refers to an already existing file, then the MyDocuments in
   * that file can be retrieved. This document-name is how you 
   * retrieve each MyDocument.
   */
  
  public String getDocumentName();
  
  
  /**
   * When a MyDocumentBuilder is closed, all the MyDocuments in it
   * are also closed. 
   * When a MyDocumentBuilder is re-opened, and its parsed node file
   * refers to an already existing file, then the MyDocuments in
   * that file can be retrieved. This document-name is how you 
   * retrieve each MyDocument.
   */

  public void setDocumentName( String documentName ) throws NodeStoreException, DOMException, MyDOMImplementationException;
}
