package au.com.explodingsheep.diskDOM;


import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.identifier.*;
import au.com.explodingsheep.diskDOM.dtdParser.*;


/**
 * My version of a DocumentType.
 */

public interface MyDocumentType extends DocumentType, java.io.Serializable, MyNode
{
  /**
   * Called by DTDParser when it parses an entity.
   */
  
  public void entityParsed( Entity entity );
  
  
  /**
   * Called by DTDParser when it parses a notation.
   */
  
  public void notationParsed( Notation notation );


  /**
   * Called by DTDParser when it parses an element declaration.
   */
  
  public void dtdElementParsed( DTDElement dtdElement );


  /**
   * Called by DTDParser when it parses an attribute list declaration.
   */
  
  public void dtdAttributeListParsed( DTDAttributeList dtdAttributeList );
  
  
  /**
   * Called when the name of a DTD has been parsed.
   */
  
  public void dtdNameParsed( String dtdName );

  
  /**
   * Returns the IdentifierList that holds all the entities.
   */
  
  public IdentifierList getEntityIdentifierList();
  
  
  /**
   * Returns the IdentifierList that holds all the notations.
   */
  
  public IdentifierList getNotationIdentifierList();


  /**
   * Returns the number of parsed elements.
   */
  
  public int getElementCount();
  
  
  /**
   * Returns an element via its offset into the list.
   */
  
  public DTDElement getDTDElement( int offset );
  
  
  /**
   * Returns an element via its offset into the list.
   */
  
  public DTDElement getDTDElement( String name );
}
