package au.com.explodingsheep.diskDOM;


import au.com.explodingsheep.diskDOM.identifier.*;


/**
 * My implementation of a Node.
 */

public interface MyNode extends org.w3c.dom.Node, java.io.Serializable
{
  /**
   * Returns the identifier that uniquely identifies this node.
   */
  
  public Identifier getIdentifier();
  
  
  /**
   * Sets the identifier for this node.
   */
  
  public void setIdentifer( Identifier identifer );
  
  
  /**
   * Returns the parent's Identifier.
   */
  
  public Identifier getParentIdentifier();


  /**
   * Sets the parent's Identifier.
   */
  
  public void setParentIdentifier( Identifier identifier );
  
  
  /**
   * Returns the list of children Identifiers for this node.
   */
  
  public IdentifierList getChildrenIdentifiers();
  

  /**
   * Returns the parent IdentifierIdentifier.
   */
  
  public IdentifierIdentifier getParentIdentifierIdentifier();


  /**
   * Returns the Identifier of the main document.
   */
  
  public Identifier getDocumentIdentifier();

  
  /**
   * If an instance of a MyNode is serialized this method
   * should be called after it has been de-serialized.
   */
  
  public void init() throws MyNodeException;
  
  
  /**
   * Sets whether this node is read-only or not.
   */
  
  public void setReadOnly( boolean readOnly );
  
  
  /**
   * Returns whether this node is read-only or not.
   */
  
  public boolean isReadOnly();
  
  
  /**
   * Does a this node to that passed, and optionally compares
   * all the child nodes as well.
   */
  
  public boolean equals( MyNode node, boolean deep );
}
