package au.com.explodingsheep.diskDOM;


import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import junit.framework.*;


/**
 * Tests the Attr interface.
 */

public class TestAttr extends TestCase
{

  /**
   * Constructor for TestAttr.
   * @param arg0
   */
  public TestAttr(String arg0)
  {
    super(arg0);
  }


//  public void testSimpleXMLFileWithDTDAndEntity() throws Exception
//  {
//    boolean result = false;
//    
//    /* First write a simple DTD declaration. */
//    FileWriter fw = new FileWriter( "/tmp/a.dtd" );
//    try
//    {
//      fw.write( "<!ELEMENT a (#CDATA)>\n" );
//      fw.write( "<!ELEMENT b (#CDATA)>\n" );
//      fw.write( "<!ELEMENT c (#CDATA)>\n" );
//      fw.write( "<!ENTITY d \"123\">\n" );
//      fw.write( "<!ENTITY e \"<c>def</c>\">\n" );
//    }
//    finally
//    {
//      fw.close();
//    }
//
//    /* Now create a simple XML file that uses the above DTD. */
//    String xml = "";
//    xml += "<!DOCTYPE a SYSTEM \"/tmp/a.dtd\">\n";
//    xml += "<a><b>&e;</b></a>";
//    ByteArrayInputStream bais = new ByteArrayInputStream( xml.getBytes() );
//    
//    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
//    DocumentBuilder db = dbf.newDocumentBuilder();
//    InputSource inputSource = new InputSource( bais );
//    Document doc = db.parse( inputSource );
//
//    ( ( DefaultMyNode ) doc ).printNode( 0, doc, true );
//  }
  
  
//  public void testAttrSetValueNoModificationAllowed() throws Exception
//  {
//    boolean result = false;
//  
//    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
//    DocumentBuilder db = dbf.newDocumentBuilder();
//    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
//    InputSource inputSource = new InputSource( is );
//    Document doc = db.parse( inputSource );
//
//    // <getElementsByTagName interface="Document" obj="doc" var="genderList" tagname="&quot;gender&quot;"/>
//    NodeList genderList = doc.getElementsByTagName( "gender" );
//
//    // Returns the 3rd gender node.
//    // <item interface="NodeList" obj="genderList" var="gender" index="2"/>
//    Node genderNode = genderList.item( 2 );
//
//    // Returns a list of child nodes of the 3rd gender node.
//    // <childNodes obj="gender" var="genList"/>
//    NodeList childrenOfGenderNode = genderNode.getChildNodes();
//    
//    // Gets the first child from the list of children of the gender node.
//    // <item interface="NodeList" obj="genList" var="gen" index="0"/>
//    Node entElement = childrenOfGenderNode.item( 0 );
//    
//    // Gets a list of children of the "entElement" node. This should be a one big and hold only the text node.
//    // <childNodes obj="gen" var="gList"/>
//    NodeList gList = entElement.getChildNodes();
//
//    // Gets the first child from the above list. This should be the text node.
//    // <item interface="NodeList" obj="gList" var="g" index="0"/>
//    Node g = gList.item( 0 );
//    
//    // Gets a list of attributes of the child of ent
//    // <attributes obj="g" var="attrList"/>
//    NamedNodeMap attrList = g.getAttributes();
//    
//    Attr attrNode = ( Attr ) attrList.getNamedItem( "domestic" );
//
//    
////      Element childElement = ( Element ) genderNode.getFirstChild();
////      Attr attr = childElement.getAttributeNode( "domestic" );
////      
////      try
////      {
////        attr.setValue( "oink" );
////      }
////      catch ( DOMException de )
////      {
////        if ( de.code ==DOMException.NO_MODIFICATION_ALLOWED_ERR )
////        {
////          result = true;
////        }
////      }
////    }
//      
//    super.assertTrue( result );
//  }
  

// ----------------------------------------------------------------------------

  
  public void testAttrCreateTextNode() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );
    try
    {
      NodeList addressList = doc.getElementsByTagName( "address" );
      Node addressElement = addressList.item( 3 );
      NamedNodeMap attributeNamedNodeMap = addressElement.getAttributes();
      Attr streetAttr = ( Attr ) attributeNamedNodeMap.getNamedItem( "street" );
      streetAttr.setValue( "Y%ent1;" );
      String s = streetAttr.getValue();
      if ( s.equals( "Y%ent1;" ) )
      {
        result = true;
      }
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }
  
    super.assertTrue( result );
  }


  public void testAttrDefaultValue() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );
    try
    {    
      NodeList addressList = doc.getElementsByTagName( "address" );
      Node addressElement = addressList.item( 0 );
      NamedNodeMap attributeNamedNodeMap = addressElement.getAttributes();
      Attr streetAttr = ( Attr ) attributeNamedNodeMap.getNamedItem( "street" );
      String s = streetAttr.getValue();
      if ( s.equals( "Yes" ) )
      {
        result = true;
      }
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }    

    super.assertTrue( result );
  }


  public void testAttrSpecifiedValue() throws Exception  
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );
    try
    {
      NodeList addressList = doc.getElementsByTagName( "address" );
      Node addressElement = addressList.item( 0 );
      NamedNodeMap attributeNamedNodeMap = addressElement.getAttributes();
      Attr domesticAttr = ( Attr ) attributeNamedNodeMap.getNamedItem( "domestic" );
      result = domesticAttr.getSpecified();
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }    

    super.assertTrue( result );
  }

  
  public void testAttrSpecifiedValueChanged() throws Exception  
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
//    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( is );
    try
    {    
      NodeList addressElementList = doc.getElementsByTagName( "address" );
      Element addressElement = ( Element ) addressElementList.item( 2 );
      addressElement.setAttribute( "street", "Yes" );
      Attr attr = addressElement.getAttributeNode( "street" );
      result = attr.getSpecified();
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }    
    
    super.assertTrue( result );
  }


  public void testAttrEntityReplacement() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );
    try
    {
      NodeList addressElementList = doc.getElementsByTagName( "address" );
      Element addressElement = ( Element ) addressElementList.item( 3 );
      Attr attr = addressElement.getAttributeNode( "street" );
      String s = attr.getValue();
      if ( s.equals( "Yes" ) )
      {
        result = true;
      }
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }    
    
    super.assertTrue( result );
  }


  public void testAttrSpecifiedValueRemove() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );
    try
    {    
      NodeList addressElementList = doc.getElementsByTagName( "address" );
      Element addressElement = ( Element ) addressElementList.item( 3 );
      
//      NamedNodeMap nnm = addressElement.getAttributes();
//      for ( int loop = 0; loop < nnm.getLength(); loop++ )
//      {
//        DefaultMyNode n = ( DefaultMyNode ) nnm.item( loop );
//        n.printNode( 0, n, true );
//      }
//      
      addressElement.removeAttribute( "street" );
      Attr attr = addressElement.getAttributeNode( "street" );
      String s = attr.getValue();
      if ( s.equals( "Yes" ) )
      {
        result = !( attr.getSpecified() );
      }
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }    
    
    super.assertTrue( result );
  }


  public void testAttrSetValueNoModificationAllowedErr() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );
    try
    {    
      NodeList genderElementList = doc.getElementsByTagName( "gender" );
      Element genderElement = ( Element ) genderElementList.item( 2 );
      EntityReference entityReference = ( EntityReference ) genderElement.getFirstChild();
      Element entElement = ( Element ) entityReference.getFirstChild();

      try
      {
        entElement.setAttribute( "domestic", "abc" );
      }
      catch ( DOMException de )
      {
        result = ( de.code == DOMException.NO_MODIFICATION_ALLOWED_ERR );
      }
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }    
    
    super.assertTrue( result );
  }
  
      
  public static Test suite()
  {
    TestSuite result = new TestSuite();
    result.addTest( new TestAttr( "testAttrSetValueNoModificationAllowed" ) );
    result.addTest( new TestAttr( "testAttrCreateTextNode" ) );
    result.addTest( new TestAttr( "testAttrDefaultValue" ) );
    result.addTest( new TestAttr( "testAttrSpecifiedValue" ) );
    return result;
  }
  

  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestAttr.class);
  }
}
