package au.com.explodingsheep.diskDOM;


import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import junit.framework.*;
import au.com.explodingsheep.diskDOM.documentBuilder.*;


/**
 * @author Daniel Caddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestCreateAndCloseDocument extends TestCase
{
  /**
   * Constructor for TestCreateAndCloseDocument.
   * @param arg0
   */
  public TestCreateAndCloseDocument(String arg0)
  {
    super(arg0);
  }


  /**
   * Tests the creation, closing and re-opening of a
   * Document. In theory the re-opened Document should have
   * the same contents as it did when it was originally created.
   */
  
  public void testCreateCloseAndReOpenDocument() throws Exception
  {
    boolean result = false;
    
    /* Delete the storage file "/tmp/MyDOM/testCreateCloseAndReOpenDocument.pdom" if it */
    /* exists.                                                                          */
    File storageFile = new File( "/tmp/MyDOM/testCreateCloseAndReOpenDocument.pdom" );
    storageFile.delete();
    
    MyDocumentBuilderFactory dbf = ( MyDocumentBuilderFactory ) DocumentBuilderFactory.newInstance();
    dbf.setStorageFileName( "/tmp/MyDOM/testCreateCloseAndReOpenDocument.pdom" );
    MyDocumentBuilder db1 = ( MyDocumentBuilder ) dbf.newDocumentBuilder();
    MyDocument document1 = ( MyDocument ) db1.newDocument();
    document1.setDocumentName( "Doc1" );

    /* Create a document with assorted elements and stuff. */
    Element e1 = document1.createElement( "a" );
    document1.appendChild( e1 );
    e1.setAttribute( "a1", "def" );
    Element e2 = document1.createElement( "b" );
    e1.appendChild( e2 );
    Comment comment = document1.createComment( "asdfgh" );
    e2.appendChild( comment );
    
    /* Close the document, then attempt to re-open it. */
    db1.close();
    
    MyDocumentBuilder db2 = ( MyDocumentBuilder ) dbf.newDocumentBuilder();
    MyDocument document2 = ( MyDocument ) db2.getDocument( "Doc1" );
    
    Element e = ( Element ) document2.getFirstChild();
    String s = e.getNodeName();
    if ( s.equals( "a" ) )
    {
      s = e.getAttribute( "a1" );
      if ( s.equals( "def" ) )
      {
        e = ( Element ) e.getFirstChild();
        s = e.getNodeName();
        if ( s.equals( "b" ) )
        {
          comment = ( Comment ) e.getFirstChild();
          
          result = true;
        }
      }
    }
    
    super.assertTrue( result );
  }    
      

  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestCreateAndCloseDocument.class);
  }

}
