package au.com.explodingsheep.diskDOM;


import java.io.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import junit.framework.*;


/**
 * Test MyDocumentFragment to make sure it creates all the various Node types.
 */

public class TestDocumentFragment extends TestCase
{
  /**
   * Constructor for TestDocument.
   * @param arg0
   */
  public TestDocumentFragment(String arg0)
  {
    super(arg0);
  }
  

public void testAddChildElementAndAttribute() throws Exception
  {
    boolean result = false;
    
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document document = db.parse( new File( "/java/DOMTestSuite/tests/files/staff.xml" ) );

    DocumentFragment documentFragment = document.createDocumentFragment();
    Element element = document.createElement( "element1" );
    Attr attr = document.createAttribute( "attr1" );
    element.setAttributeNode( attr );
    documentFragment.appendChild( element );
    
    Node node = documentFragment.getFirstChild();
    if ( node.equals( element ) );
    {
      Element e1 = ( Element ) node;
      Attr a1 = e1.getAttributeNode( "attr1" );
      if ( a1.equals( attr ) )
      {
        result = true;
      }
    }

    super.assertTrue( result );
  }


  public void testAddChildElementAndAttribute2() throws Exception
  {
    boolean result = false;

    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document document = db.parse( new File( "/Java/DOMTestSuite/tests/files/staff.xml" ) );
    
    DocumentFragment documentFragment = document.createDocumentFragment();
    Element element = document.createElement( "element1" );
    element.setAttribute( "attr1", "attrvalue" );
    documentFragment.appendChild( element );
    
    Node node = documentFragment.getFirstChild();
    if ( node.equals( element ) );
    {
      Element e1 = ( Element ) node;
      String s = e1.getAttribute( "attr1" );
      if ( s.equals( "attrvalue" ) )
      {
        result = true;
      }
    }

    super.assertTrue( result );
  }

  
  static Test suite()
  {
    TestSuite result = new TestSuite();
    result.addTest( new TestDocumentFragment( "testAddChildElementAndAttribute" ) );
    result.addTest( new TestDocumentFragment( "testAddChildElementAndAttribute2" ) );
    return result;
  }


  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestDocumentFragment.class);
  }
}
