package au.com.explodingsheep.diskDOM;

import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import junit.framework.*;


/**
 * Tests my EntityReference class.
 */

public class TestEntityReference extends TestCase
{

  /**
   * Constructor for TestEntityReference.
   * @param arg0
   */
  public TestEntityReference(String arg0)
  {
    super(arg0);
  }



//  /**
//   * Tests the addition of a known entity reference to an XML tree.
//   * The children of the new entity reference should be its nodes.
//   */
//
//  public void testAddEntityReferenceToXMLTree() throws Exception
//  {
//    boolean result = false;
//
//    /* Write a simple DTD with one entity reference. */
//    FileWriter fw = new FileWriter( "/tmp/a.dtd" );
//    try
//    {
//      fw.write( "<!ELEMENT a (#CDATA)>\n" );
//      fw.write( "<!ELEMENT b (#CDATA)>\n" );
//      fw.write( "<!ELEMENT c (#CDATA)>\n" );
//      fw.write( "<!ENTITY d \"<c>def</c>\">\n" );
//    }
//    finally
//    {
//      fw.close();
//    }
//
//    /* Now create a simple XML file that uses the above DTD. */
//    String xml = "";
//    xml += "<!DOCTYPE a SYSTEM \"/tmp/a.dtd\">\n";
//    xml += "<a><b>&e;</b></a>";
//    ByteArrayInputStream bais = new ByteArrayInputStream( xml.getBytes() );
//    
//    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
//    DocumentBuilder db = dbf.newDocumentBuilder();
//    InputSource inputSource = new InputSource( bais );
//    Document doc = db.parse( inputSource );
//
//    Element a = doc.getDocumentElement();
//    Element b = ( Element ) a.getFirstChild();
//    
//    /* Now we add an entity reference to "b". Under it should be */
//    /* the entity reference's children.                           */
//    EntityReference er = doc.createEntityReference( "d" );
//    b.appendChild( er );
//    
//    Node n = b.getFirstChild();
//    if ( n.equals( er ) )
//    {
//      Element c = ( Element ) n.getFirstChild();
//      String s = c.getNodeName();
//      if ( s.equals( "c" ) )
//      {
//        Text t = ( Text ) c.getFirstChild();
//        s = t.getNodeValue();
//        if ( s.equals( "def" ) )
//        {
//          result = true;
//        }
//      }
//    }
//    
//    super.assertTrue( result );
//  }


  public void testNodeCloneNodeTrue() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );
    try
    {    
      NodeList employeeElementList = doc.getElementsByTagName( "employee" );
      Element employeeElement = ( Element ) employeeElementList.item( 1 );
      Node clonedEmployeeNode = employeeElement.cloneNode( true );
      
      result = true;
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) doc.getImplementation();
      di.close();
    }    
    
    super.assertTrue( result );
  }
  

  public static Test Suite()
  {
    TestSuite result = new TestSuite();
    
    result.addTest( new TestEntityReference( "testAddEntityReferenceToXMLTree" ) );
    
    return result;    
  }


  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestEntityReference.class);
  }
}
