package au.com.explodingsheep.diskDOM;


import junit.framework.*;
import org.w3c.dom.*;
import javax.xml.parsers.*;


/**
 * Tests the NamedNodeMap interface.
 */

public class TestNamedNodeMap extends TestCase
{
  /**
   * Constructor for TestNamedNodeMap.
   * @param arg0
   */
  public TestNamedNodeMap(String arg0)
  {
    super(arg0);
  }
  
  
  /**
   * Tests what happens when we replace one value in a NamedNodeMap
   * with another. In theory the old value should be returned.
   */
  
  public void testReplaceAttributeWithAnother() throws Exception
  {
    boolean result = false;
    
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document document = db.newDocument();

    Element e = document.createElement( "Element1" );
    Attr a1 = document.createAttribute( "a1" );
    e.setAttributeNode( a1 );

    Attr a2 = document.createAttribute( "a1" );
    
    NamedNodeMap nnm = e.getAttributes();
    
    Attr a3 = ( Attr ) nnm.setNamedItem( a2 );
    
    String attrName2 = a2.getNodeName();
    String attrName3 = a3.getNodeName();
    
    result = attrName2.equals( attrName3 );
    
    super.assertTrue( result );
  }

  
  public static Test suite()
  {    
    TestSuite result = new TestSuite();
    result.addTest( new TestNamedNodeMap( "testReplaceAttributeWithAnother" ) );
    return result;
  }
  

  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestNamedNodeMap.class);
  }
}
