package au.com.explodingsheep.diskDOM;


import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import junit.framework.*;


/**
 * @author Daniel Caddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestNode extends TestCase
{

  /**
   * Constructor for TestNode.
   * @param arg0
   */
  public TestNode(String arg0)
  {
    super(arg0);
  }


  public void testCreateElementAndAttribute() throws Exception
  {
//    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    DefaultMyDocument doc = ( DefaultMyDocument ) db.newDocument();
    
    Element e1 = doc.createElement( "abc" );
    Element e2 = doc.createElement( "def" );
    
    doc.appendChild( e1 );
    
    e1.appendChild( e2 );
    
    super.assertTrue( true );
  }
    
    
  public void testReplaceChildNoModificationAllowedErr() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    DefaultMyDocument doc = ( DefaultMyDocument) db.parse( inputSource );
    
    NodeList genderList = doc.getElementsByTagName( "gender" );
    Element gender = ( Element ) genderList.item( 2 );
    DefaultMyEntityReference er = ( DefaultMyEntityReference) gender.getFirstChild();
    Element oldElement = ( Element ) er.getFirstChild();
    Element newElement = ( Element ) doc.createElement( "NewElement" );

    try
    {
      er.replaceChild( newElement, oldElement );
    }
    catch ( DOMException de )
    {
      result = ( de.code == DOMException.NO_MODIFICATION_ALLOWED_ERR );
    }
        
    super.assertTrue( result );
  }


  public void testNodeCDATASectionNodeName() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    DefaultMyDocument doc = ( DefaultMyDocument) db.parse( inputSource );

    NodeList nameList = doc.getElementsByTagName( "name" );
    Node name = nameList.item( 1 );

    Node cdata = name.getLastChild();
    String s = cdata.getNodeName();
    result = ( s.equals( "#cdata-section" ) );
        
    super.assertTrue( result );
  }


  public void testNodeProcessingInstructionSetNodeValue() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    DefaultMyDocument doc = ( DefaultMyDocument) db.parse( inputSource );

//    System.out.println( "*********************************************" );
//    DefaultMyNode.printNode( 0, doc, true );

    NodeList allChildren = doc.getChildNodes();
    ProcessingInstruction pi = ( ProcessingInstruction ) allChildren.item( 0 );

    pi.setData( "abc" );
    
    super.assertTrue( true );
  }


  public void testNodeDocumentTypeNodeName() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    DefaultMyDocument doc = ( DefaultMyDocument) db.parse( inputSource );

    DocumentType docType = doc.getDoctype();
    String dtdName = docType.getNodeName();
    
    result = dtdName.equals( "staff" );
    
    super.assertTrue( result );
  }


  public void testNodeCloneNodeTrue() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    DefaultMyDocument doc = ( DefaultMyDocument) db.parse( inputSource );

    NodeList employeeList = doc.getElementsByTagName( "employee" );
    Node employee = employeeList.item( 1 );
    Node clonedEmployee = employee.cloneNode( true );
    
    result = true;
    
    super.assertTrue( result );
  }

//  public void testNodeInsertBeforeDocFragment() throws Exception
//  {
//    boolean result = false;
//  
//    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
//    DocumentBuilder db = dbf.newDocumentBuilder();
//    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
//    InputSource inputSource = new InputSource( is );
//    MyDocument doc = ( MyDocument ) db.parse( inputSource );
//
//    DocumentFragment df = doc.createDocumentFragment();
//    Element e1 = doc.createElement( "newElement1" );
//    Element e2 = doc.createElement( "newElement1" );
//    df.appendChild( e1 );
//    df.appendChild( e2 );
//    
//    
//
//    NodeList nameList = doc.getElementsByTagName( "name" );
//    Node name = nameList.item( 1 );
//
//    System.out.println( "*********************************************" );
//    DefaultMyNode.printNode( 0, name, true );
//
//    Node cdata = name.getLastChild();
//    String s = cdata.getNodeName();
//    result = ( s.equals( "#cdata-section" ) );
//        
//    super.assertTrue( result );
//  }
    

  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestNode.class);
  }

}
