package au.com.explodingsheep.diskDOM;


import java.io.*;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;
import junit.framework.*;


/**
 * @author Daniel Caddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestProcessingInstruction extends TestCase
{

  /**
   * Constructor for TestProcessingInstruction.
   * @param arg0
   */
  public TestProcessingInstruction(String arg0)
  {
    super(arg0);
  }


  public void testSetDataNoModificationAllowedErr() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );

    NodeList genderList = doc.getElementsByTagName( "gender" );
    Node gender = genderList.item( 2 );
    Node entityReference = gender.getFirstChild();
    
    DefaultMyNode.printNode( 0, entityReference, true );
    
    ProcessingInstruction pi = ( ProcessingInstruction ) entityReference.getLastChild();
    
    try
    {
      pi.setData( "abc" );
    }
    catch ( DOMException di )
    {
      if ( di.code == DOMException.NO_MODIFICATION_ALLOWED_ERR )
      {
        result = true;
      }
    }
    
    super.assertTrue( result );
  }
  


  public void testProcessingInstructionGetTarget() throws Exception
  {
    boolean result = false;
  
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    InputStream is = new FileInputStream( "/Java/DOMTestSuite/tests/files/staff.xml" );
    InputSource inputSource = new InputSource( is );
    Document doc = db.parse( inputSource );

    NodeList children = doc.getChildNodes();
    ProcessingInstruction pi = ( ProcessingInstruction ) children.item( 0 );
    String target = pi.getTarget();
    if ( target.equals( "TEST-STYLE" ) )
    {
      result = true;
    }
    
    super.assertTrue( result );
  }


  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestProcessingInstruction.class);
  }
}
