package au.com.explodingsheep.diskDOM;


import java.util.ArrayList;
import org.w3c.dom.NodeList;
import org.w3c.dom.Node;


/**
 * This class implements NodeList, except that it does not
 * automatically reflect any changes to the underlying XML tree
 * structure. It is a quick attempt to provide support for
 * the Element method "getElementsByTagName".
 */

public class UnChangingNodeList extends ArrayList implements NodeList
{
  /**
   * Returns the indexth item in the collection. If index is 
   * greater than or equal to the number of nodes in the list, 
   * this returns null. 
   */
  
  public Node item(int index)
  {
    Node result = null;
    int numItemsInList = super.size();
    if ( index < numItemsInList )
    {
      result = ( Node ) super.get( index );
    }
    return result;
  }
  
  
  /**
   * The number of nodes in the list. The range of valid child 
   * node indices is 0 to length-1 inclusive. 
   */
  
  public int getLength()
  {
    int result = super.size();
    return result;
  }
}
