package au.com.explodingsheep.diskDOM.documentBuilder;


import org.w3c.dom.*;
import org.xml.sax.*;
import java.io.*;
import au.com.explodingsheep.diskDOM.*;
import au.com.explodingsheep.diskDOM.dtdParser.*;


/**
 * My version of a DocumentBuilder.
 * Includes 
 */

public abstract class MyDocumentBuilder extends javax.xml.parsers.DocumentBuilder
{
  /**
   * Extended version of "parse" that specifies the Document that the
   * parsed XML nodes will be added to.
   * It also specifies that first root node that all other parsed 
   * nodes will be children of.
   */  
  
  public abstract Node parse(InputSource is, MyDocument document, Node rootNode ) throws SAXException, IOException;


  /**
   * Extended version of "parse" that specifies the Document that the
   * parsed XML nodes will be added to.
   */  
  
  public abstract Node parse(InputSource is, DefaultMyDocument document ) throws SAXException, IOException;
  
  
  /**
   * Returns the DTDParser used when parsing the document.
   */
  
  public abstract DTDParser getDTDParser();
  
  
  /**
   * Closes this class and its DOMImplementation.
   */
  
  public abstract void close() throws MyDocumentBuilderException;
  
  
  /**
   * Loads and returns the document with the passed Identifier.
   */
  
  public abstract MyDocument getDocument( String documentName ) throws MyDocumentBuilderException;
  
  
  /**
   * Returns the names of all the MyDocuments in this
   * DocumentBuilder.
   */
  
  public abstract String[] getDocumentNames() throws MyDocumentBuilderException;
}
