package au.com.explodingsheep.diskDOM.documentBuilder;


import org.w3c.dom.*;
import junit.framework.*;
import au.com.explodingsheep.diskDOM.*;
import java.io.*;
import javax.xml.parsers.*;


/**
 * @author Daniel Caddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestMyDocumentBuilder extends TestCase
{

  /**
   * Constructor for TestMyDocumentBuilder.
   * @param arg0
   */
  public TestMyDocumentBuilder(String arg0)
  {
    super(arg0);
  }


  /**
   * Runs the processing of a source XML file.
   * Given the input XML "<a><b c="def">ghi</b></a>" make
   * sure the resulting DOM tree looks correct.
   */
  
  public void testBuildDocument() throws Exception
  {
    boolean result = false;

    String srcXML = "<a><b c=\"def\">ghi</b></a>";
    InputStream is = new ByteArrayInputStream( srcXML.getBytes() );
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    DocumentBuilder db = dbf.newDocumentBuilder();
    Document document = db.parse( is );
    try
    {
      /* Confirm that the shape of the DOM tree is correct. */
      Node nodeA = document.getFirstChild();
      if ( ( nodeA.getNodeName().equals( "a" ) ) 
        && ( nodeA instanceof Element ) )
      {
        NodeList childNodes = nodeA.getChildNodes();
        int numChildNodes = childNodes.getLength();
        if ( numChildNodes == 1 )
        {
          Node nodeB = nodeA.getFirstChild();
          NamedNodeMap attributes = nodeB.getAttributes();
          if ( attributes.getLength() == 1 )
          {
            Element elementB = ( Element ) nodeB;
            String attributeValue = elementB.getAttribute( "c" );
            if ( attributeValue.equals( "def" ) )
            {
              if ( nodeB.getChildNodes().getLength() == 1 )
              {
                Node textNode = nodeB.getFirstChild();
                if ( textNode instanceof Text )
                {
                  String s = textNode.getNodeValue();
                  if ( s.equals( "ghi" ) )
                  {
                    result = true;
                  }
                }
              }
            }
          }
        }
      }
    }
    finally
    {
      MyDOMImplementation di = ( MyDOMImplementation ) document.getImplementation();
      di.close();
    }

    super.assertTrue( result );
  }

    
  static Test suite()
  {
    TestSuite result = new TestSuite();
    result.addTest( new TestMyDocumentBuilder( "testBuildDocument" ) );
    return result;
  }


  public static void main(String[] args)
  {
//    junit.swingui.TestRunner.run(TestMyDocumentBuilder.class);
    junit.textui.TestRunner.run(TestMyDocumentBuilder.class);


//    try
//    {
//      TestMyDocumentBuilder tmdb = new TestMyDocumentBuilder();
//      tmdb.testBuildDocument();
//    }
//    catch ( Exception e )
//    {
//      e.printStackTrace();
//    }
    
  }
}
