package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * When a DTDElement has child elements, the child information is 
 * stored here. It has only the child's name, and count of how many 
 * instances of the child there can be. The other DTDElement 
 * information for the child is held in a separate DTDElement instance.
 */

public interface ChildDTDElement
{
  /* Used in getMaximumCount to mean that there is no upper limit. */
  public static final int NO_MAXIMUM_CHILDREN = -1;


  /**
   * Returns the name of the child element.
   */
  
  public String getName();
  
  
  /**
   * Returns the minimum number of instances of a child
   * there must be.
   */
  
  public int getMinimumCount();
  
  
  /**
   * Returns the maximum number of instances of a child
   * there must be.
   */
  
  public int getMaximumCount();
}
