package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Holds the zero or more child DTD elements that are the children
 * of a element, and the number of instances of this list there
 * can be for the parent element.
 * 
 * Ie a there can be zero or more ChildDTDElement instances in a
 * ChildDTDElementList, and the can be zero or more ChildDTDElementList
 * instances in a DTDElement.
 */

public interface ChildDTDElementList
{
  /**
   * Returns the number of ChildDTDElements in this list.
   */
  
  public int size();
  
  
  /**
   * Returns a ChildDTDElement instance or null of offset is
   * out of range.
   */
  
  public ChildDTDElement getChildDTDElement( int offset );
  
  
  /**
   * Adds a ChildDTDElement to the list.
   */
  
  public void add( ChildDTDElement child );


  /**
   * Returns the minimum number of instances of a child
   * there must be.
   */
  
  public int getMinimumCount();
  
  
  /**
   * Returns the maximum number of instances of a child
   * there must be.
   */
  
  public int getMaximumCount();


  /**
   * Sets the minimum number of instances of a child
   * there must be.
   */
  
  public void setMinimumCount( int min );
  
  
  /**
   * Sets the maximum number of instances of a child
   * there must be.
   */
  
  public void setMaximumCount( int max );
}
