package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Defines an attribute declaration in the DTD.
 */

public interface DTDAttribute
{
  /**
   * Returns the name of the element.
   */
  
  public String getName();

  
  /**
   * Returns the datatype of the element (if it has data).
   */
  
  public int getDataType();


  /**
   * Returns the attribute's default value or null if there
   * isn't one.
   */
  
  public String getDefaultValue();  
  
  
  /**
   * Returns whether the attribute is required or not.
   */
  
  public boolean isRequired();
  
  
  /**
   * Returns if the attribute is implied or not.
   */
  
  public boolean isImplied();
}
