package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Holds a list of DTDAttributes that are associated with a DTDElement.
 */

public interface DTDAttributeList
{
  /**
   * Returns the number of DTDAttributes in this list.
   */
  
  public int size();


  /**
   * Returns a DTDAttributes or null if "offset" is out of range.
   */
  
  public DTDAttribute getDTDAttribute( int offset );
  

  /**
   * Returns a DTDAttributes or null if the passed attribute name
   * is not in the list.
   */
  
  public DTDAttribute getDTDAttribute( String attributeName );

  
  /**
   * Adds a DTDAttribute to the list.
   */
  
  public void add( DTDAttribute attribute );
  
  
  /**
   * Returns the name of the element these attributes are asociated with.
   */
  
  public String getElementName();
}
