package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Defines a DTD element definition.
 * Holds the element's name, type, children elements.
 */

public interface DTDElement
{
  /**
   * Returns the name of the element.
   */
  
  public String getName();
  
  
  /**
   * Returns whether the element has data, or children elements.
   */
  
  public boolean hasChildren();
  
  
  /**
   * Returns the datatype of the element (if it has data).
   */
  
  public int getDataType();
  
  
  /**
   * Returns the list of children elements for this element
   * (if this element has children).
   */
  
  public ChildDTDElementList getChildList();
  
  
  /**
   * Returns the attributes for this node, or null if there
   * are none.
   */
  
  public DTDAttributeList getDTDAttributes();
}
