package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Implements the ChildDTDElement interface.
 */

public class DefaultChildDTDElement implements ChildDTDElement, java.io.Serializable
{
  protected String name = null;
  protected int min = 1;
  protected int max = 1;
  

  /**
   * Constructor.
   */
  
  public DefaultChildDTDElement( String name, int min, int max )
  {
    this.name = name;
    this.min = min;
    this.max = max;
  }
    

  /**
   * Returns the name of the child element.
   */
  
  public String getName()
  {
    return this.name;
  }
  
  
  /**
   * Returns the minimum number of instances of a child
   * there must be.
   */
  
  public int getMinimumCount()
  {
    return this.min;
  }
  
  
  /**
   * Returns the maximum number of instances of a child
   * there must be.
   */
  
  public int getMaximumCount()
  {
    return this.max;
  }
}
