package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Implements ChildDTDElementList.
 */

public class DefaultChildDTDElementList extends java.util.ArrayList implements ChildDTDElementList, java.io.Serializable
{
  protected int min = 1;
  protected int max = 1;
  
  
  /**
   * Constructor.
   */
  
  public DefaultChildDTDElementList()
  {
  }
  
    
  /**
   * Returns a ChildDTDElement instance or null of offset is
   * out of range.
   */
  
  public ChildDTDElement getChildDTDElement( int offset )
  {
    ChildDTDElement result = null;
    int size = super.size();
    if ( ( offset >= 0 ) && ( offset < size ) )
    {  
      result = ( ChildDTDElement ) super.get( offset );
    }
    return result;
  }

  
  /**
   * Adds a ChildDTDElement to the list.
   */
  
  public void add( ChildDTDElement child )
  {
    super.add( child );
  }


  /**
   * Returns the minimum number of instances of a child
   * there must be.
   */
  
  public int getMinimumCount()
  {
    return this.min;
  }
  
  
  /**
   * Returns the maximum number of instances of a child
   * there must be.
   */
  
  public int getMaximumCount()
  {
    return this.max;
  }


  /**
   * Sets the minimum number of instances of a child
   * there must be.
   */
  
  public void setMinimumCount( int min )
  {
    this.min = min;
  }
  
  
  /**
   * Sets the maximum number of instances of a child
   * there must be.
   */
  
  public void setMaximumCount( int max )
  {
    this.max = max;
  }
}
