package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Implements the DTDAttribute interface.
 */

public class DefaultDTDAttribute implements DTDAttribute, java.io.Serializable
{
  protected String name = null;
  protected int dataType = DTDDataTypes.NO_DATA_TYPE;
  protected String defaultValue = null;
  protected boolean required = false;
  protected boolean implied = false;


  /**
   * Constructor.
   */
  
  public DefaultDTDAttribute( String name, int dataType, String defaultValue, boolean required, boolean implied )
  {
    this.name = name;
    this.dataType = dataType;
    this.defaultValue = defaultValue;
    this.required = required;
    this.implied = implied;
  }
  
  
  /**
   * Returns the name of the element.
   */
  
  public String getName()
  {
    return this.name;
  }

  
  /**
   * Returns the datatype of the element (if it has data).
   */
  
  public int getDataType()
  {
    return this.dataType;
  }


  /**
   * Returns the attribute's default value or null if there
   * isn't one.
   */
  
  public String getDefaultValue()
  {
    return this.defaultValue;
  }
  
  
  /**
   * Returns whether the attribute is required or not.
   */
  
  public boolean isRequired()
  {
    return this.required;
  }
  
  
  /**
   * Returns if the attribute is implied or not.
   */
  
  public boolean isImplied()
  {
    return this.implied;
  }
}
