package au.com.explodingsheep.diskDOM.dtdParser;


/**
 * Implements the DTDAttributeList interface.
 */

public class DefaultDTDAttributeList extends java.util.ArrayList implements DTDAttributeList, java.io.Serializable
{
  protected String elementName = null;
  
  
  /**
   * Constructor.
   */
  public DefaultDTDAttributeList( String elementName )
  {
    this.elementName = elementName;
  }
  
  
  /**
   * Returns a DTDAttributes or null of "offset" is out of range.
   */
  
  public DTDAttribute getDTDAttribute( int offset )
  {
    DTDAttribute result = null;
    int size = super.size();
    if ( ( offset >= 0 ) && ( offset < size ) )
    {  
      result = ( DTDAttribute ) super.get( offset );
    }
    return result;
  }


  /**
   * Returns a DTDAttributes or null if the passed attribute name
   * is not in the list.
   */
  
  public DTDAttribute getDTDAttribute( String attributeName )
  {
    DTDAttribute result = null;
    int size = super.size();
    int loop = 0;
    while ( loop < size )
    {
      DTDAttribute attribute = this.getDTDAttribute( loop );
      String name = attribute.getName();
      if ( name.equals( attributeName ) )
      {
        result = attribute;
        loop = size;
      }
      else
      {
        loop++;
      }
    }
    
    return result;
  }
  
  
  /**
   * Adds a DTDAttribute to the list.
   */
  
  public void add( DTDAttribute attribute )
  {
    super.add( attribute );
  }

  
  /**
   * Returns the name of the element these attributes are asociated with.
   */
  
  public String getElementName()
  {
    return this.elementName;
  }
}
