package au.com.explodingsheep.diskDOM.helpers;


/**
 * A helper class to handle if errors or exceptions happen.
 */

import org.w3c.dom.DOMException;


public class ErrorHandler
{
  /* DOM exception code we use when we generate a DOM exception. */
  protected static final short DOM_EXCEPTION_NUM = 0;


  /**
   * This is where we handle any exceptions that happen while 
   * dealing with requests, but cannot pass them to the caller
   * as the Node specification doesn't define an exception.
   */
  
  public static void throwException( Exception e )
  {
    e.printStackTrace();
    
    throw new DOMException( DOM_EXCEPTION_NUM, e.getMessage() );
  }

  
  /**
   * We call this if we need to throw an exception because of
   * some problem.
   */
  
  public static void throwException( String msg )
  {
    throw new DOMException( DOM_EXCEPTION_NUM, msg );
  }
}
