package au.com.explodingsheep.diskDOM.helpers;


/**
 * Helper static methods to convert an int into an array of four bytes
 * and back again.
 */

public class IntToBytes
{
  /**
   * Turns the passed int into 4 bytes.
   */

  public static void intToBytes( int i, byte[] b )
  {
    b[0] = ( byte ) ( i & 255 );
    b[1] = ( byte ) ( ( i >> 8 ) & 255 );
    b[2] = ( byte ) ( ( i >> 16 ) & 255 );
    b[3] = ( byte ) ( ( i >> 24 ) & 255 );
  }


  /**
   * Turns the passed 4 bytes into an integer.
   */

  public static int bytesToInt( byte[] bytes )
  {
    int result = bytes[0] & 255;
    result |= ( bytes[1] & 255 ) << 8;
    result |= ( bytes[2] & 255 ) << 16;
    result |= ( bytes[3] & 255 ) << 24;
    return result;
  }
}
