package au.com.explodingsheep.diskDOM.highLevelTests;


import java.io.*;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import javax.xml.transform.dom.*;
import javax.xml.transform.stream.*;
import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.documentBuilder.*;


public class ExampleTransform
{
  /**
   * Transforms XML data using the standard Transformer.
   */
  
  public static void main( String args[] )  
  {
    try
    {
      MyDocumentBuilderFactory dbf = ( MyDocumentBuilderFactory ) DocumentBuilderFactory.newInstance();
      dbf.setStorageFileName( "/tmp/MyDOM/ParsedData.dom" );
      dbf.setIgnoringElementContentWhitespace( true );
      MyDocumentBuilder db = ( MyDocumentBuilder ) dbf.newDocumentBuilder();

      InputStream is = new FileInputStream( "/tmp/TestData.xml" );
      try
      {
        Document srcDocument = db.parse( is );
  
        javax.xml.transform.TransformerFactory tFactory = javax.xml.transform.TransformerFactory.newInstance();
        Source xslSource = new StreamSource( new FileInputStream( "/tmp/Tfansform.xsl" ) );
        Transformer transformer2 = tFactory.newTransformer( xslSource );

        DOMSource domSource = new DOMSource( srcDocument );
        StreamResult streamResult = new StreamResult( new FileOutputStream( "/tmp/TransformedData.xml" ) );
        transformer2.transform( domSource, streamResult );
      }
      finally
      {
        is.close();
        db.close();
      }
    }    
    catch ( Exception e )
    {
      e.printStackTrace();
    }
  }
}
