package au.com.explodingsheep.diskDOM.highLevelTests;


import junit.framework.TestCase;
import javax.xml.parsers.*;
import org.w3c.dom.*;
import au.com.explodingsheep.diskDOM.*;
import au.com.explodingsheep.diskDOM.identifier.*;
import au.com.explodingsheep.diskDOM.documentBuilder.*;


/**
 * @author Daniel Caddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestCreateMultipleDocuments extends TestCase
{

  /**
   * Constructor for TestCreateMultipleDocuments.
   * @param arg0
   */
  public TestCreateMultipleDocuments(String arg0)
  {
    super(arg0);
  }


  /**
   * Tests creating multiple documents, closing and re-opening the
   * DocumentBuilder, and seeing if all the Documents are still there.
   */
  
  public void testCreateMultipleDocuments() throws Exception
  {
    boolean result = false;
    
    MyDocumentBuilderFactory dbf = ( MyDocumentBuilderFactory ) DocumentBuilderFactory.newInstance();
    dbf.setStorageFileName( "/tmp/MyDOM/testCreateMultipleDocuments.pdom" );
    dbf.setIgnoringElementContentWhitespace( true );
    MyDocumentBuilder db = ( MyDocumentBuilder ) dbf.newDocumentBuilder();

    /* Create the first document then close the builder. */
    MyDocument doc1 = ( MyDocument ) db.newDocument();
    Identifier identifier1 = doc1.getIdentifier();
    Element doc1e1 = doc1.createElement( "Element1" );
    doc1.appendChild( doc1e1 );
    Element doc1e2 = doc1.createElement( "Element2" );
    doc1e1.appendChild( doc1e2 );
    doc1e1.setAttribute( "Attr1", "Value1" );
    doc1.setDocumentName( "Doc1" );
    db.close();
    
    /* Re-open the pdom file and create a second document. */
    db = ( MyDocumentBuilder ) dbf.newDocumentBuilder();
    MyDocument doc2 = ( MyDocument  ) db.newDocument();
    Identifier identifier2 = doc2.getIdentifier();
    Element doc2e1 = doc2.createElement( "Element3" );
    doc2.appendChild( doc2e1 );
    Text doc2t1 = doc2.createTextNode( "Text1" );
    doc2e1.appendChild( doc2t1 );
    doc2.setDocumentName( "Doc2" );
    db.close();
    
    /* Re-open the builder, create a third document. */
    db = ( MyDocumentBuilder ) dbf.newDocumentBuilder();
    MyDocument doc3 = ( MyDocument  ) db.newDocument();
    Identifier identifier3 = doc3.getIdentifier();
    Element doc3e1 = doc3.createElement( "Element4" );
    doc3.appendChild( doc3e1 );
    doc3e1.setAttribute( "Attr2", "abc" );
    doc3e1.setAttribute( "Attr3", "def" );
    doc3.setDocumentName( "Doc3" );
    db.close();

    /* Do all the document still exist and contain the write nodes? */    
    db = ( MyDocumentBuilder ) dbf.newDocumentBuilder();
    MyDOMImplementation di = ( MyDOMImplementation ) db.getDOMImplementation();
    MyDocument doc1a = ( MyDocument ) di.getDocument( "Doc1" );
    MyDocument doc2a = ( MyDocument ) di.getDocument( "Doc2" );
    MyDocument doc3a = ( MyDocument ) di.getDocument( "Doc3" );
    
    Element e = doc1a.getDocumentElement();
    if ( ( e.getNodeName().equals( "Element1" ) )
      && ( e.getAttribute( "Attr1" ).equals( "Value1" ) )
      && ( e.getFirstChild().getNodeName().equals( "Element2" ) ) )
    {
      e = doc2a.getDocumentElement();
      if ( ( e.getNodeName().equals( "Element3" ) )
        && ( e.getFirstChild().getNodeValue().equals( "Text1" ) ) )
      {
        e = doc3a.getDocumentElement();
        if ( ( e.getNodeName().equals( "Element4" ) )
          && ( e.getAttribute( "Attr2" ).equals( "abc") )
          && ( e.getAttribute( "Attr3" ).equals( "def") ) )
        {
          result = true;
        }
      }
    }
    
    super.assertTrue( result );
  }


  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestCreateMultipleDocuments.class);
  }

}
