package au.com.explodingsheep.diskDOM.highLevelTests;


import java.util.Calendar;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import au.com.explodingsheep.diskDOM.*;
import au.com.explodingsheep.diskDOM.documentBuilder.*;


/**
 *  Times how long it takes to write 1000 nodes
 * versus 10000 nodes.
 */

public class TimeNodeStore
{
  public static int createNodes( Document document, int numNodesToCreate ) throws Exception
  {
    Calendar calendar = Calendar.getInstance();
    long startMilliseconds = calendar.getTimeInMillis();

    Element rootElement = document.createElement( "RootElement" );
    document.appendChild( rootElement );

    for ( int loop = 0; loop < numNodesToCreate; loop++ )
    {
      Element element = document.createElement( "abc" );
      int i = numNodesToCreate % 10;
      Element parentElement = element;
      for ( int loop2 = 0; loop2 < i; loop2++ )
      {
        Element childElement = document.createElement( "defgh" );
        parentElement.appendChild( childElement );
        parentElement = childElement;
        
        if ( loop2 % 3 == 0 )
        {
          parentElement.setAttribute( "qwe", "rty" );
        }
      }
      
      rootElement.appendChild( element );
    }
    
    calendar = Calendar.getInstance();
    long endMilliseconds = calendar.getTimeInMillis();
    
    int result = ( int ) ( endMilliseconds - startMilliseconds );
    return result;
  }
  
  
  public static void main( String args[] )
  {
    try
    {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      MyDocumentBuilder db = ( MyDocumentBuilder ) dbf.newDocumentBuilder();
      Document doc = db.newDocument();
      
      MyDOMImplementation di = ( MyDOMImplementation ) db.getDOMImplementation();
      
      
      int milliseconds1 = createNodes( doc, 10000 );
      System.out.println( "Time1 = " + milliseconds1 );
      
      int milliseconds2 = createNodes( doc, 100000 );
      System.out.println( "Time2 = " + milliseconds2 );
      
      float f1 = milliseconds2 / 10;
      float f2 = f1 / ( float ) milliseconds1;
      System.out.println( "Slowdown = " + f2 );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
    }
  }
}
