package au.com.explodingsheep.diskDOM.highLevelTests;


import java.util.Calendar;
import org.w3c.dom.*;
import javax.xml.parsers.*;
import au.com.explodingsheep.diskDOM.*;
import au.com.explodingsheep.diskDOM.stringStore.*;
import au.com.explodingsheep.diskDOM.documentBuilder.*;


/**
 * Tests to see if there is any slowdown in the creation or
 * processing of stringstores as the number written increases.
 */

public class TimeStringStore
{
  public static int createStringStores( StringStore ss, int numStringStoresToCreate ) throws Exception
  {
    Calendar calendar = Calendar.getInstance();
    long startMilliseconds = calendar.getTimeInMillis();

    for ( int loop = 0; loop < numStringStoresToCreate; loop++ )
    {
      String s = "";
      int i = numStringStoresToCreate % 64;
      for ( int loop2 = 0; loop2 < i; loop2++ )
      {
        s += ( char ) ( loop2 + 65 );
      }
      ss.appendString( s );
    }
    
    calendar = Calendar.getInstance();
    long endMilliseconds = calendar.getTimeInMillis();
    
    int result = ( int ) ( endMilliseconds - startMilliseconds );
    return result;
  }
  
  
  public static void main( String args[] )
  {
    try
    {
      DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
      MyDocumentBuilder db = ( MyDocumentBuilder ) dbf.newDocumentBuilder();
      Document doc = db.newDocument();
      
      MyDOMImplementation di = ( MyDOMImplementation ) db.getDOMImplementation();
      StringStore ss = di.getStringStore();
      
      
      int milliseconds1 = createStringStores( ss, 10000 );
      System.out.println( "Time1 = " + milliseconds1 );
      
      int milliseconds2 = createStringStores( ss, 100000 );
      System.out.println( "Time2 = " + milliseconds2 );
      
      float f1 = milliseconds2 / 10;
      float f2 = f1 / ( float ) milliseconds1;
      System.out.println( "Slowdown = " + f2 );
    }
    catch ( Exception e )
    {
      e.printStackTrace();
    }
  }
}
