package au.com.explodingsheep.diskDOM.identifier;


import java.io.Serializable;


/**
 * These are used to uniquely identify things in this system.
 * For example a Node has one of these to identify itself when
 * it is serialized and de-serialized. A Node will refer to its
 * parent and children nodes via these things.
 * 
 * Sub-instances are used in cooperation with appropriate resource
 * managers (NodeStore, StringStore, IdentifierStore etc) to store 
 * and retrieve a node or its data.
 */

public interface Identifier extends Serializable
{
}
