package au.com.explodingsheep.diskDOM.identifier;


/**
 * A common place to create new unique Identifiers. 
 * An IdentifierGeneratorThese is created and managed by
 * a DOMInstance. Each IdentifierGenerator will create 
 * unique Identifiers within the scope of that DOMInstance.
 */

public interface IdentifierGenerator
{
  /**
   * Returns a new unique Identifier.
   */
  
  public Identifier createIdentifier();


  /**
   * Closes this object.
   */
  
  public void close() throws IdentifierGeneratorException;
}
