package au.com.explodingsheep.diskDOM.identifier;


/**
 * This interface is used to identify an Identifier.
 * We use this in DefaultMyNode to refer to its parent MyNode.
 * The parent can change, and if we have multiple instances of
 * the MyNode in existance and one's parent changes the rest 
 * must reflect that change. If we just stored the parent's
 * Identifier in the MyNode then that change wouldn't be
 * reflected.
 * It is like a pointer to a value, it provides one level of
 * indirection.
 */

public interface IdentifierIdentifier extends java.io.Serializable
{
}
