package au.com.explodingsheep.diskDOM.identifier;


/**
 * An Identifier that uses an integer as the things that
 * makes it unique. All the resource managers I have
 * written assume that Identifiers are actually IntIdentifier.
 */

public class IntIdentifier implements Identifier
{
  /* This value means we don't have a valid value for the identifier. */
  public static final int INVALID_VALUE = -1;
  
  protected int value = IntIdentifier.INVALID_VALUE;

  
  public IntIdentifier( int value )
  {
    this.value = value;
  }
  
  
  public int getValue()
  {
    return this.value;
  }
  
  
  public boolean equals( Object o )
  {
    boolean result = false;
    if ( o instanceof IntIdentifier )
    {
      IntIdentifier intIdentifier = ( IntIdentifier ) o;
      int i = intIdentifier.getValue();
      if ( i == this.value )
      {
        result = true;
      }
    }
    return result;
  }
}
