package au.com.explodingsheep.diskDOM.identifier;


import junit.framework.*;
import au.com.explodingsheep.diskDOM.simpleFileSystem.*;


/**
 * @author dcaddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestIdentifierIdentifierStore extends TestCase
{

  /**
   * Constructor for TestIdentifierIdentifierStore.
   * @param arg0
   */
  public TestIdentifierIdentifierStore(String arg0)
  {
    super(arg0);
  }
  
  
  public void testEverything() throws Exception
  {
    boolean result = false;
    
    
     BlockIO blockIO = new FileBlockIO( "/tmp/testEverything" );
    SimpleFileSystem sfs = new DefaultSimpleFileSystem( blockIO );
    try
    {
      IdentifierStore iis = new SimpleFileSystemIdentifierStore( sfs );

      Identifier i1 = new IntIdentifier( 1 );
      Identifier i2 = new IntIdentifier( 2 );
      Identifier i3 = new IntIdentifier( 3 );
      
      IdentifierIdentifier ii1 = iis.appendIdentifier( i1 );
      IdentifierIdentifier ii2 = iis.appendIdentifier( i2 );
      
      Identifier i1a = iis.getIdentifier( ii1 );
      if ( i1.equals( i1a ) )
      {
        iis.setIdentifier( ii2, i3 );
        Identifier i3a = iis.getIdentifier( ii2 );
        if ( i3a.equals( i3 ) )
        {
          result = true;
        }
      }
    }
    finally
    {
      sfs.close();
      blockIO.close();
    }
    
    super.assertTrue( result );
  }
  
  
   public static Test suite()
  {
    TestSuite result = new TestSuite();
    result.addTest( new TestIdentifierIdentifierStore( "testEverything" ) );
    return result;
  }
  

  public static void main(String[] args)
  {
    junit.swingui.TestRunner.run(TestIdentifierIdentifierStore.class);
  }
}
