package au.com.explodingsheep.diskDOM.identifier;


import junit.framework.*;
import au.com.explodingsheep.diskDOM.simpleFileSystem.*;


/**
 * @author dcaddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestIdentifierStore extends TestCase
{

  /**
   * Constructor for TestIdentifierIdentifierStore.
   * @param arg0
   */
  public TestIdentifierStore(String arg0)
  {
    super(arg0);
  }
  
  
  public boolean testIdentifierStore( IdentifierStore is ) throws Exception
  {
    boolean result = false;
    
    Identifier i1 = new IntIdentifier( 1 );
    Identifier i2 = new IntIdentifier( 2 );
    Identifier i3 = new IntIdentifier( 3 );
    
    IdentifierIdentifier ii1 = is.appendIdentifier( i1 );
    IdentifierIdentifier ii2 = is.appendIdentifier( i2 );
    
    Identifier i1a = is.getIdentifier( ii1 );
    if ( i1.equals( i1a ) )
    {
      is.setIdentifier( ii2, i3 );
      Identifier i3a = is.getIdentifier( ii2 );
      if ( i3a.equals( i3 ) )
      {
        result = true;
      }
    }
    
    return result;
  }
  

  public void testFileIdentifierStore() throws Exception
  {
    BlockIO blockIO = new RAMBlockIO();
    SimpleFileSystem sfs = new DefaultSimpleFileSystem( blockIO );
    IdentifierStore is = new SimpleFileSystemIdentifierStore( sfs );
    boolean result = this.testIdentifierStore( is );
    super.assertTrue( result );
  }

  
   public static Test suite()
  {
    TestSuite result = new TestSuite();
    result.addTest( new TestIdentifierStore( "testFileIdentifierStore" ) );
    return result;
  }
  

  public static void main(String[] args)
  {
    junit.swingui.TestRunner.run(TestIdentifierStore.class);
  }
}
