package au.com.explodingsheep.diskDOM.simpleFileSystem;


import junit.framework.TestCase;


/**
 * Tests the blockmap manager class.
 */

public class TestDefaultBlockMapManager extends TestCase
{
  protected BlockMapManager bmm = null;


  /**
   * Constructor for TestSimpleFileSystemBlockMapManager.
   * @param arg0
   */
  public TestDefaultBlockMapManager(String arg0)
  {
    super(arg0);
  }

  
  public void setUp() throws Exception
  {
    this.bmm = new DefaultBlockMapManager();
    this.bmm.setNumBlocks( 1024 );
  }


  public void tearDown() throws Exception
  {
    this.bmm.close();
  }


  public void testLockingAndUnlockingBlocks() throws Exception
  {
    boolean result = true;
    int loop;
    
    for ( loop = 0; loop < 1024; loop++ )
    {
      this.bmm.lockBlock( loop );
    }
    
    for ( loop = 0; loop < 1024; loop++ )
    {
      boolean b = this.bmm.isBlockLocked( loop );
      if ( b == false )
      {
        System.out.println( "A   " + loop );
        result = false;
      }
    }
    
    for ( loop = 0; loop < 1024; loop++ )
    {
      this.bmm.unlockBlock( loop );
    }
    
    for ( loop = 0; loop < 1024; loop++ )
    {
      boolean b = this.bmm.isBlockLocked( loop );
      if ( b == true )
      {
        System.out.println( "B   " + loop );
        result = false;
      }
    }

    for ( loop = 0; loop < 1024; loop += 2 )
    {
      this.bmm.lockBlock( loop );
      this.bmm.unlockBlock( loop + 1 );
    }
    
    for ( loop = 0; loop < 1024; loop += 2 )
    {
      boolean b1 = this.bmm.isBlockLocked( loop );
      boolean b2 = this.bmm.isBlockLocked( loop + 1 );
      if ( ( b1 == false ) || ( b2 == true ) )
      {
        System.out.println( "C   " + loop );
        result = false;
      }
    }

    for ( loop = 0; loop < 1024; loop += 4 )
    {
      this.bmm.lockBlock( loop );
      this.bmm.unlockBlock( loop + 1 );
      this.bmm.unlockBlock( loop + 2 );
      this.bmm.unlockBlock( loop + 3 );
    }
    
    for ( loop = 0; loop < 1024; loop += 4 )
    {
      boolean b1 = this.bmm.isBlockLocked( loop );
      boolean b2 = this.bmm.isBlockLocked( loop + 1 );
      boolean b3 = this.bmm.isBlockLocked( loop + 2 );
      boolean b4 = this.bmm.isBlockLocked( loop + 3 );
      if ( ( b1 == false ) || ( b2 == true )  || ( b3 == true ) || ( b4 == true ) )
      {
        System.out.println( "D   " + loop );
        result = false;
      }
    }

    for ( loop = 0; loop < 1024; loop += 4 )
    {
      this.bmm.unlockBlock( loop );
      this.bmm.lockBlock( loop + 1 );
      this.bmm.lockBlock( loop + 2 );
      this.bmm.lockBlock( loop + 3 );
    }
    
    for ( loop = 0; loop < 1024; loop += 4 )
    {
      boolean b1 = this.bmm.isBlockLocked( loop );
      boolean b2 = this.bmm.isBlockLocked( loop + 1 );
      boolean b3 = this.bmm.isBlockLocked( loop + 2 );
      boolean b4 = this.bmm.isBlockLocked( loop + 3 );
      if ( ( b1 == true ) || ( b2 == false )  || ( b3 == false ) || ( b4 == false ) )
      {
        System.out.println( "E   " + loop );
        result = false;
      }
    }


    super.assertTrue( result );    
  }
    

  public static void main(String[] args)
  {
    junit.textui.TestRunner.run(TestDefaultBlockMapManager.class);
  }

}
