package au.com.explodingsheep.diskDOM.stringStore;


import au.com.explodingsheep.diskDOM.identifier.*;


/**
 * This interface defines a way to load and store strings to a persistent
 * spot, referring to them by a Serializable key.
 */

public interface StringStore
{
  /**
   * Saves a string to some persistent spot, and
   * returns a key that uniquely identifies the string.
   */
  
  public Identifier appendString( String s ) throws StringStoreException;


  /**
   * Saves a string to some persistent spot, and
   * returns a key that uniquely identifies the string.
   */
  
  public void setString( Identifier identifier, String s ) throws StringStoreException;


  /**
   * Retrieves a string from the persistent spot.
   */
  
  public String getString( Identifier identifier ) throws StringStoreException;
  
  
  /**
   * Closes this object.
   */
  
  public void close() throws StringStoreException;
}
