package au.com.explodingsheep.diskDOM.stringStore;


import junit.framework.*;
import au.com.explodingsheep.diskDOM.identifier.*;
import au.com.explodingsheep.diskDOM.simpleFileSystem.*;


/**
 * @author dcaddy
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */

public class TestStringStore extends TestCase
{

  /**
   * Constructor for TestStringStore.
   * @param arg0
   */
  public TestStringStore(String arg0)
  {
    super(arg0);
  }


  protected boolean testStringStore( StringStore ss ) throws Exception
  {
    boolean result = false;
    
    Identifier si1 = ss.appendString( "abc" );
    Identifier si2 = ss.appendString( "def1234" );
    Identifier si3 = ss.appendString( "abcdefghijklmnopqrstuvwxyz1234567890abcdefghijklmnopqrstuvwxyz1234567890abcdefghijklmnopqrstuvwxyz1234567890" );
    
    String s1 = ss.getString( si1 );
    String s2 = ss.getString( si2 );
    String s3 = ss.getString( si3 );
    if ( ( s1.equals( "abc" ) )
      && ( s2.equals( "def1234" ) )
      && ( s3.equals( "abcdefghijklmnopqrstuvwxyz1234567890abcdefghijklmnopqrstuvwxyz1234567890abcdefghijklmnopqrstuvwxyz1234567890" ) ) )
    {
      ss.setString( si2, "rewqwe" );
      s2 = ss.getString( si2 );
      if ( s2.equals( "rewqwe" ) )
      {
        result = true;
      }
    }
    
    return result;
  }


//  public void testRAMStringStore() throws Exception
//  {
//    StringStore ss = new RAMStringStore();
//    boolean result = this.testStringStore( ss );
//    super.assertTrue( result );
//  }


  public void testSimpleFileSystemStringStore() throws Exception
  {
    boolean result = false;
    BlockIO blockIO = new FileBlockIO( "/tmp/testSimpleFileSystemStringStore" );
    SimpleFileSystem sfs = new DefaultSimpleFileSystem( blockIO );
    try
    {
      StringStore ss = new SimpleFileSystemStringStore( sfs );
      result = this.testStringStore( ss );
    }
    finally
    {
      sfs.close();
      blockIO.close();
    }
    super.assertTrue( result );
  }


  public static Test suite()
  {
    TestSuite result = new TestSuite();
//    result.addTest( new TestStringStore( "testRAMStringStore" ) );
    result.addTest( new TestStringStore( "testSimpleFileSystemStringStore" ) );
    return result;
  }


  public static void main(String[] args)
  {
    junit.swingui.TestRunner.run(TestStringStore.class);
  }
}
